from SheetProviders import SheetProviderContainer
from PlugIns import PlugInContainer

_marker = []

class Implementor(SheetProviderContainer, PlugInContainer):
    """Implementor - provides implementation services for an abstract type"""
    pass

class Traversable:
    """Make implementor bobo-traversable"""

    def __bobo_traverse__(self, REQUEST, name):
        ob = getattr(self, name, _marker)
        if ob is _marker:
            ob = self.getItem(name)
            if ob is not None:
                return getattr(ob,'aq_base',ob).__of__(self)
            raise 'NotFound'
        return ob

